
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Hibernate之旅 / 憋错料</title>

    <meta name="description" content="Hibernate之旅 Hibernate之旅一:创建demo 前言 最近在学习Hibernate,貌似起步晚了些.以前都只是在用,没有进行系统地学习.刚刚开通了博客,想写一些学习笔记.如有错误之处,望列位指正,不甚感激. 环境准备 jdk1.8.eclipse.mysql数据库. 相关jar包.antlr.jar.cglib.jar.asm.jar.asm-attrs.jar.commons-collections.jar.commons-logging.jar.ehcache.jar.hibernate3.jar.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Hibernate之旅</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>Hibernate之旅一：创建demo</h1>
<h1>前言</h1>
<p>　　最近在学习Hibernate，貌似起步晚了些。以前都只是在用，没有进行系统地学习。刚刚开通了博客，想写一些学习笔记。如有错误之处，望列位指正，不甚感激。</p>
<h1>环境准备</h1>
<ul>
<li>jdk1.8、eclipse、mysql数据库。</li>
<li>相关jar包。antlr.jar、cglib.jar、asm.jar、asm-attrs.jar、commons-collections.jar、commons-logging.jar、ehcache.jar、hibernate3.jar、jta.jar、dom4.jar、log4j.jar。(创建maven工程更为方便，我这儿恰好有相关jar包就直接导入了）。</li>
</ul>
<h1>数据库准备</h1>
<ul>
<li>首先创建数据库hibernatedb：CREATE DATABASE hibernatedb DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;</li>
<li>创建用户user1,密码也是user1：CREATE USER ‘user1‘@‘localhost‘ IDENTIFIED BY ‘user1‘;--该处为localhost则代表只能本地访问；如果为%表示匹配所有主机（并不包括localhost）。</li>
<li>授权给用户：GRANT ALL PRIVILEGES ON hibernatedb.* TO user1; --ALL PRIVILEGES表示所有权限，*代表整个数据库。</li>
<li>刷新用户权限：FLUSH&nbsp;PRIVILEGES;</li>
<li>创建表userinfo：</li>
</ul>
<p>USE DATABASE hibernatedb;--使用hibernatedb数据库</p>
<p>CREATE TABLE userinfo(</p>
<p>userId INT PRIMARY KEY AUTO_INCREMENT,</p>
<p>userName VARCHAR(20) NOT NULL,</p>
<p>userPassword VARCHAR(20) NOT NULL</p>
<p>);</p>
<ul>
<li>最终数据库和表结构如下。</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwMTI1NzIvMjAxNzAzLzEwMTI1NzItMjAxNzAzMDUwMTAzMTIyNTEtNjUzMDEzOTEzLnBuZw==.jpg"></p>
<h1>创建demo</h1>
<ul>
<li>hibernate基本配置文件:hibernate.cfg.xml；该配置文件放置在类路径下。</li>
</ul>

<pre> 1 &lt;?xml version="1.0" encoding="UTF-8"?&gt;
 2 &lt;!DOCTYPE hibernate-configuration PUBLIC
 3         "-//Hibernate/Hibernate Configuration DTD 3.0//EN"
 4         "http://hibernate.sourceforge.net/hibernate-configuration-3.0.dtd"&gt;
 5 &lt;hibernate-configuration&gt;
 6     &lt;session-factory&gt;
 7         &lt;property name="hibernate.connection.driver_class"&gt;com.mysql.jdbc.Driver&lt;/property&gt;
 8         &lt;property name="hibernate.connection.username"&gt;user1&lt;/property&gt;
 9         &lt;property name="hibernate.connection.password"&gt;user1&lt;/property&gt;
10         &lt;property name="hibernate.connection.url"&gt;jdbc:mysql://localhost:3306/hibernatedb&lt;/property&gt;
11         &lt;!-- 配置数据库方言 --&gt;
12         &lt;property name="hibernate.dialect"&gt;org.hibernate.dialect.MySQLDialect&lt;/property&gt;
13         &lt;property name="connection.pool_size"&gt;1&lt;/property&gt;
14         &lt;!-- 输出运行时生成的SQL语句 --&gt;
15         &lt;property name="show_sql"&gt;true&lt;/property&gt;
16         &lt;!-- 列出所有的映射文件 --&gt;
17         &lt;mapping resource="org/hibernate/entity/UserInfo.hbm.xml" /&gt;
18     &lt;/session-factory&gt;
19 &lt;/hibernate-configuration&gt;</pre>

<ul>
<li>新建一个简单的JavaBean:UserInfo类。持久化类都要求有无参构造器，Hibernate必须使用Java反射机制来创建对象。</li>
</ul>

<pre> 1 package org.hibernate.entity;
 2 /**
 3  *
 4  * 功能：测试用用户类
 5  * @author liaody
 6  * @version 1.0
 7  * @date 2017年3月5日 上午12:26:20
 8  */
 9 public class UserInfo {
10
11     private int userId;
12     private String userName;
13     private String userPassword;
14
15     /**
16      * default constructor
17      */
18     public UserInfo (){
19
20     }
21
22     /**
23      * full constructor
24      * @param userId
25      * @param userName
26      * @param userPassword
27      */
28     public UserInfo(int userId,String userName,String userPassword){
29         this.userId = userId;
30         this.userName = userName;
31         this.userPassword = userPassword;
32     }
33
34     /**
35      * @return the userId
36      */
37     public int getUserId() {
38         return this.userId;
39     }
40
41     /**
42      * @return the userName
43      */
44     public String getUserName() {
45         return this.userName;
46     }
47
48     /**
49      * @return the userPassword
50      */
51     public String getUserPassword() {
52         return this.userPassword;
53     }
54
55     /**
56      * @param userId the userId to set
57      */
58     public void setUserId(int userId) {
59         this.userId = userId;
60     }
61
62     /**
63      * @param userName the userName to set
64      */
65     public void setUserName(String userName) {
66         this.userName = userName;
67     }
68
69     /**
70      * @param userPassword the userPassword to set
71      */
72     public void setUserPassword(String userPassword) {
73         this.userPassword = userPassword;
74     }
75
76
77
78
79 }</pre>

<ul>
<li>UserInfo类的映射文件UserInfo.hbm.xml，该文件放置在与UserInfo类同一个包（org.hibernate.entity）下。</li>
</ul>

<pre> 1 &lt;?xml version="1.0" encoding="UTF-8"?&gt;
 2 &lt;!DOCTYPE hibernate-mapping PUBLIC "-//Hibernate/Hibernate Mapping DTD 3.0//EN"
 3 "http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd"&gt;
 4 &lt;hibernate-mapping&gt;
 5     &lt;class name="org.hibernate.entity.UserInfo" table="USERINFO"&gt;
 6         &lt;id name="userId" type="java.lang.Integer" column="userid"&gt;
 7             &lt;generator class="increment" /&gt;
 8         &lt;/id&gt;
 9         &lt;property name="userName" type="java.lang.String"&gt;
10             &lt;column name="userName" length="20"&gt;&lt;/column&gt;
11         &lt;/property&gt;
12         &lt;property name="userPassword" type="java.lang.String"&gt;
13             &lt;column name="userPassword" length="20"&gt;&lt;/column&gt;
14         &lt;/property&gt;
15     &lt;/class&gt;
16 &lt;/hibernate-mapping&gt;</pre>

<ul>
<li>创建辅助工具类HibernateUtil，用于获取和管理Session。</li>
</ul>

<pre> 1 package org.hibernate.util;
 2
 3 import org.hibernate.*;
 4 import org.hibernate.cfg.*;
 5
 6 public class HibernateUtil {
 7     private static SessionFactory sessionFactory;
 8     private static Configuration configuration = new Configuration();
 9     // 创建线程局部变量threadLocal，用来保存Hibernate的Session
10     private static final ThreadLocal&lt;Session&gt; threadLocal = new ThreadLocal&lt;Session&gt;();
11     // 使用静态代码块初始化Hibernate
12     static {
13         try {
14             Configuration cfg = new Configuration().configure(); // 读取配置文件hibernate.cfg.xml
15             sessionFactory = cfg.buildSessionFactory(); // 创建SessionFactory
16         } catch (Throwable ex) {
17             throw new ExceptionInInitializerError(ex);
18         }
19     }
20
21     // 获得SessionFactory实例
22     public static SessionFactory getSessionFactory() {
23         return sessionFactory;
24     }
25
26     // 获得ThreadLocal 对象管理的Session实例.
27     public static Session getSession() throws HibernateException {
28         Session session = (Session) threadLocal.get();
29         if (session == null || !session.isOpen()) {
30             if (sessionFactory == null) {
31
32                 rebuildSessionFactory();
33             }
34             // 通过SessionFactory对象创建Session对象
35             session = (sessionFactory != null) ? sessionFactory.openSession()
36                     : null;
37             // 将新打开的Session实例保存到线程局部变量threadLocal中
38             threadLocal.set(session);
39         }
40         return session;
41     }
42
43     // 关闭Session实例
44     public static void closeSession() throws HibernateException {
45         // 从线程局部变量threadLocal中获取之前存入的Session实例
46         Session session = (Session) threadLocal.get();
47         threadLocal.set(null);
48         if (session != null) {
49             session.close();
50         }
51     }
52
53     // 重建SessionFactory
54     public static void rebuildSessionFactory() {
55         try {
56             configuration.configure("/hibernate.cfg.xml"); // 读取配置文件hibernate.cfg.xml
57             sessionFactory = configuration.buildSessionFactory(); // 创建SessionFactory
58         } catch (Exception e) {
59             System.err.println("Error Creating SessionFactory ");
60             e.printStackTrace();
61         }
62     }
63
64     // 关闭缓存和连接池
65     public static void shutdown() {
66         getSessionFactory().close();
67     }
68 }</pre>

<ul>
<li>Dao接口</li>
</ul>

<pre> 1 package org.hibernate.dao;
 2
 3 import org.hibernate.entity.UserInfo;
 4
 5 public interface UserInfoDao {
 6
 7     void save(UserInfo user); // 添加用户
 8
 9     UserInfo findById(int id); // 根据用户标识查找指定用户
10
11     void delete(UserInfo user); // 删除用户
12
13     void update(UserInfo user); // 修改用户信息
14 }</pre>

<ul>
<li>Dao接口实现</li>
</ul>

<pre> 1 package org.hibernate.dao.impl;
 2
 3 import org.hibernate.Session;
 4 import org.hibernate.Transaction;
 5 import org.hibernate.dao.UserInfoDao;
 6 import org.hibernate.entity.UserInfo;
 7 import org.hibernate.util.HibernateUtil;
 8
 9 public class UserInfoDaoImpl implements UserInfoDao {
10     // 添加用户
11     public void save(UserInfo user) {
12         Session session = HibernateUtil.getSession(); // 生成Session实例
13         Transaction tx = session.beginTransaction(); // 创建Transaction实例
14         try {
15             session.save(user); // 使用Session的save方法将持久化对象保存到数据库
16             tx.commit(); // 提交事务
17         } catch (Exception e) {
18             e.printStackTrace();
19             tx.rollback(); // 回滚事务
20         } finally {
21             HibernateUtil.closeSession(); // 关闭Session实例
22         }
23     }
24
25     // 根据用户标识查找指定用户
26     public UserInfo findById(int userId) {
27         UserInfo user = null;
28         Session session = HibernateUtil.getSession(); // 生成Session实例
29         Transaction tx = session.beginTransaction(); // 创建Transaction实例
30         try {
31             user = (UserInfo) session.get(UserInfo.class, userId); // 使用Session的get方法获取指定id的用户到内存中
32             tx.commit(); // 提交事务
33         } catch (Exception e) {
34             e.printStackTrace();
35             tx.rollback(); // 回滚事务
36         } finally {
37             HibernateUtil.closeSession(); // 关闭Session实例
38         }
39         return user;
40     }
41
42     // 删除用户
43     public void delete(UserInfo user) {
44         Session session = HibernateUtil.getSession(); // 生成Session实例
45         Transaction tx = session.beginTransaction(); // 创建Transaction实例
46         try {
47             session.delete(user); // 使用Session的delete方法将持久化对象删除
48             tx.commit(); // 提交事务
49         } catch (Exception e) {
50             e.printStackTrace();
51             tx.rollback(); // 回滚事务
52         } finally {
53             HibernateUtil.closeSession(); // 关闭Session实例
54         }
55     }
56
57     // 修改用户信息
58     public void update(UserInfo user) {
59         Session session = HibernateUtil.getSession(); // 生成Session实例
60         Transaction tx = session.beginTransaction(); // 创建Transaction实例
61         try {
62             session.update(user); // 使用Session的update方法更新持久化对象
63             tx.commit(); // 提交事务
64         } catch (Exception e) {
65             e.printStackTrace();
66             tx.rollback(); // 回滚事务
67         } finally {
68             HibernateUtil.closeSession(); // 关闭Session实例
69         }
70     }
71
72 }</pre>

<ul>
<li>测试</li>
</ul>

<pre> 1 package org.hibernate.test;
 2
 3 import org.hibernate.dao.UserInfoDao;
 4 import org.hibernate.dao.impl.UserInfoDaoImpl;
 5 import org.hibernate.entity.UserInfo;
 6 import org.junit.Before;
 7 import org.junit.Test;
 8
 9 public class UserInfoTest {
10
11     @Before
12     public void setUp() throws Exception {
13
14     }
15
16     @Test
17     public void testSave() {
18         UserInfoDao userdao = new UserInfoDaoImpl();
19         UserInfo  user = new UserInfo(); // 创建UserInfo对象
20         // 设置UserInfo对象中的各个属性值
21         user.setUserName("liaody");
22         user.setUserPassword("456");
23         userdao.save(user); // 使用UserInfoDao的save方法将UserInfo对象存入数据库
24
25     }
26 }</pre>

<ul>
<li>测试结果</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwMTI1NzIvMjAxNzAzLzEwMTI1NzItMjAxNzAzMDUxMDU1MzgyMzUtMjY3OTEyMjE0LnBuZw==.jpg"></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwMTI1NzIvMjAxNzAzLzEwMTI1NzItMjAxNzAzMDUxMDU2NDQ2NzMtMTY3NDQxNDgwMC5wbmc=.jpg"></p>
<ul>
<li>目录结构</li>
</ul>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzEwMTI1NzIvMjAxNzAzLzEwMTI1NzItMjAxNzAzMDUxMDU3NDc1MDEtMTI1MDg0NDI2OC5wbmc=.jpg"></p>
<h1>总结</h1>
<p>这儿只是一个demo，为了能使用Hibernate进行增删改查，代码和结构之后会逐步完善。接下来将会对hibernate进行系统的学习。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 17:01:28 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/maven/" title="maven">maven</a>, <a href="https://www.biecuoliao.com/tag/read/" title="read">read</a>, <a href="https://www.biecuoliao.com/tag/%e9%80%9a%e8%bf%87/" title="通过">通过</a>, <a href="https://www.biecuoliao.com/tag/user/" title="user">user</a>, <a href="https://www.biecuoliao.com/tag/efault/" title="efault">efault</a>, <a href="https://www.biecuoliao.com/tag/nal/" title="nal">nal</a>, <a href="https://www.biecuoliao.com/tag/local/" title="local">local</a>, <a href="https://www.biecuoliao.com/tag/cte/" title="cte">cte</a>, <a href="https://www.biecuoliao.com/tag/userinfo/" title="userinfo">userinfo</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Hibernate之旅的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEogLD3.html" rel="bookmark">Java之旅hibernate（8）&mdash;&mdash;基本关系映射</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				何为关系,何为映射,关系这个词想必大家都不陌生.比方你和老师之间是师生关系,你和父母之间是父子或者父女(母子或者母女关系). 关系是存在某种联系物体之间产生的.什么都是可能的.比方你和工具,你仅仅能使用工具,可是工具不能使用你.这种关系是单向的.可是换种说法.你拥有工具,工具也属于你,那么这种关系就是双向的了,此外一个人能够拥有多个工具,而且多个工具也能够是属于一个人的.还有就是多个人拥有多个工具,而且多个工具也属于人,依据这些特征,我们将关系分为下面几种: 单向关系: one2one,(一对一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OZZ280.html" rel="bookmark">Java之旅hibernate（3）&mdash;&mdash;第一个hibernate的样例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在解说样例之前.我们首先来理解一下hibernate的工作原理.理解原理将会帮助我们更好地理解hibernate和运用hibernate. 1.      原理图 利用hibernate进行数据的持久化操作,必定离不开与数据库打交道.依据上张图我们来看看hibernate是怎样工作的. watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQv/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gra			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bK2do3.html" rel="bookmark">Hibernate学习之旅</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hibernate搭建步骤: 1.下载所需包:antlr-2.7.7.jar,dom4j-1.6.1.jar,hibernate-commons-annotations-4.0.2.Final.jar,hibernate-core-4.2.21.Final.jar,hibernate-jpa-2.0-api-1.0.1.Final.jar,javassist-3.18.1-GA.jar,jboss-logging-3.1.0.GA.jar,jboss-transaction-api_1.1_sp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aQDyA0.html" rel="bookmark">【SSH之旅】一步步学习Hibernate框架（一）：关于持久化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在不引用不论什么框架下,我们会通过平庸的代码不停的对数据库进行操作,产生了非常多冗余的可是又有规律的底层代码,这样频繁的操作数据库和大量的底层代码的反复书写极大的浪费了程序人员的书写.就在这样一种情况下,Hibernate框架应运而生了. 事实上Hibernate封装的就是Model模型中的model,封装的这部分又叫持久层.在这层中对对象进行加入.删除.更新.查询等操作就叫做持久化. 持久化的对象有三种状态:Transient Objects.Persist Objects.Detached			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pqKDRM.html" rel="bookmark">【SSH之旅】一步步学习Hibernate框架（二）：一对一关联映射中的主键关联</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一对一的映射在对象模型中是经常见到的,主要是将对象模型转换为关系模型就必须在映射文件中进行配置,重点是&lt;one-to-one&gt;标签的使用,有两种方式,第一是主键关联,第二是唯一外键关联,现在先来看第一种方式. 一对一的关联映射中的主键关联,就是说两个对象具有相同的主键值,以表明它们之间的一一对应的关系,数据库表不会有额外的字段来维护它们之间的关系,仅仅是通过表的主键来关联. 上图的Person类和IdCard类之间是一一对应关系,一个人就只能有一个身份证,一个身份证只能对应一个人,那么身份证的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jeeY9M.html" rel="bookmark">Java之旅hibernate（6）&mdash;&mdash;Junit不为人知的故事</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  说道Junit,我们首先不得不说測试的重要性.一个健壮的软件肯定是经过不断地的測试后才干终于被应用的.在測试的过程中能够发现非常多不稳定性或者说是存在一定的bug等等.这些都能够在測试阶段发现.而不会被推到被用户真正的使用的时候.避免了不良好的用户体验. 当我们看java源程序的时候.总是会看到这种一个目录,名字为test,好奇的你是否点开过呢? 没错,这里就是我们书写的測试程序,使得在团队开发过程中.彼此的交互更加的可靠和稳定. 那么Junti详细是什么呢? 1.       Junit			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a7wAq4.html" rel="bookmark">深入hibernate的三种状态&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学过hibernate的人都可能都知道hibernate有三种状态,transient(瞬时状态),persistent(持久化状态)以及detached(离线状态),大家伙也许也知道这三者之间的区别,比如瞬时状态就是刚new出来一个对象,还没有被保存到数据库中,持久化状态就是已经被保存到数据库中,离线状态就是数据库中有,但是session中不存在该对象.但是大家又是否对hibernate的session的那几个特殊方法一清二楚呢?或者说大家是否能够一眼就快速看出一个测试用例在反复的调用sess			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myw5la3.html" rel="bookmark">深入hibernate的三种状态</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学过hibernate的人都可能都知道hibernate有三种状态,transient(瞬时状态),persistent(持久化状态)以及detached(离线状态),大家伙也许也知道这三者之间的区别,比如瞬时状态就是刚new出来一个对象,还没有被保存到数据库中,持久化状态就是已经被保存到数据库中,离线状态就是数据库中有,但是session中不存在该对象.但是大家又是否对hibernate的session的那几个特殊方法一清二楚呢?或者说大家是否能够一眼就快速看出一个测试用例在反复的调用sess			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a7AdR4.html" rel="bookmark">Hibernate Validator</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 在项目的业务属性中,你是不是要经常验证属性的取值范围呢. 想要了解比较优美的解决方案吗? 看看Hibernate Validator 是怎么做的吧.一见到她,相信你就会说: Oh God, 这就是我需要的. 作者:icess(作者的blog:http://blog.matrix.org.cn/page/icess)关键字:Hibernate Validator               用Annotations 给类或者类的属性加上约束(constraint),在运行期检查属性值是很优			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/7MV55z4.html" rel="bookmark" class="title">gevent</a>
					<div>
						gevent是一个基于协程的python网络库. 特性: 1.基于libev的事件循环 2.基于greenlet 轻量级的执行单元  (what is greenlet ?) 3.来自python标准 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8pen0.html" rel="bookmark" class="title">上手并过渡到PHP7（4）&mdash;&mdash;取代fatal error的engine exceptions</a>
					<div>
						上手并过渡到PHP7 取代fatal error的engine exceptions 泊学原文链接泊学代码秀视频 自从PHP 4以来,PHP的错误处理几乎就是一成不变的.只不过在PHP 5.0里添加了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoYVzn3.html" rel="bookmark" class="title">GNS3 模拟icmp重定向</a>
					<div>
						网关实质上是一个网络通向其他网络的IP地址.比如有网络A和网络B,网络A的IP地址范围为“192.168.1.1~192. 168.1.254”,子网掩码为255.255.255.0:网络B的IP地址 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEZnlD0.html" rel="bookmark" class="title">&lbrack;C&num;&rsqb;readonly vs const</a>
					<div>
						C#中的readonly和const两个关键字都可以用来定义系统变量,那两者之间有什么区别呢? 1. const变量赋值后,就不可以对其进行修改.且在定义时就需要给它赋值,使用const修饰的变量是s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5wlK3.html" rel="bookmark" class="title">数组中的运用</a>
					<div>
						通过foreach来遍历一个数组(重要,要求掌握) 语法:foreach(数组名 as $value) 还有一个用法:语法: Foreach(数组名 as $key =&gt;$value) 3)li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAZWVM.html" rel="bookmark" class="title">Nodejs之MEAN栈开发（五）-- Angular入门与页面改造</a>
					<div>
						这个系列一共会涉及两个JavaScript框架的讲解,一个是Express用做后端,一个是Angular用于前端.和Express一样,Angular分离内容,处理视图.数据和逻辑.和MVC模式很相似 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mr9o0.html" rel="bookmark" class="title">golang zip 压缩，解压（含目录文件）</a>
					<div>
						每天学习一点go src. 今天学习了zip包的简单使用,实现了含目录的压缩与解压. 写了两个方法,实现了压缩.解压. package ziptest import ( &quot;archive/z ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWaoY3.html" rel="bookmark" class="title">数据库之SQL编程</a>
					<div>
						定义局部变量 declare @num int 途径一:set @num=5 途径二:select @num=5 set 和select赋值方式的区别 唯一区别,如果从数据库表中获取数据,只能用 se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wAK1M.html" rel="bookmark" class="title">格式工厂&lpar;一&rpar;</a>
					<div>
						版权声明:本文为博主原创文章,未经博主允许不得转载. 本节主要介绍C++的新特性,对于C++的基础语法不再讲解.由于编译器的不同.在某些地方可能有些差异,但是无太大影响. 讲解本节知识之前先确认你的C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglorN0.html" rel="bookmark" class="title">数据库访问--web服务器</a>
					<div>
						//http.h #pragma once #include&lt;stdio.h&gt; #include&lt;stdlib.h&gt; #include&lt;string.h&gt; #inc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zPBvM.html" rel="bookmark" class="title">c&plus;&plus; 实现Sring类</a>
					<div>
						深拷贝实现string类 #define _CRT_SECURE_NO_WARNING 1 #include&lt;iostream&gt; #include&lt;string&gt; using  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvN5n3.html" rel="bookmark" class="title">【Java-加密算法】对称加密、非对称加密、单向散列</a>
					<div>
						一提到加密,就会联想到数字签名,这两个经常被混淆的概念到底是什么呢? 加密:加密是一种以密码方式发送信息的方法.只有拥有正确密钥的人才能解开这个信息的密码.对于其他人来说,这个信息看起来就像是一系列随 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLADJ4.html" rel="bookmark" class="title">freemarker标签大全</a>
					<div>
						FreeMarker的插值有如下两种类型:1,通用插值${expr};2,数字格式化插值:#{expr}或#{expr;format} ${book.name?if_exists }  //用于判断如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgYNDn3.html" rel="bookmark" class="title">Smack&plus;Openfire 文件接收与发送</a>
					<div>
						转载请说明出处:http://blog.csdn.net/steelychen/article/details/37958839 发送文件需要提供准确的接收放用户名称(例:[email protect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPemoy0.html" rel="bookmark" class="title">Qt for Android遇到的几个错误解决&lbrack;Win7 &plus; Qt5&period;6 &plus;jdk 8u91&rsqb;</a>
					<div>
						[1]SDK Manager无法更新Android SDK安装后需要运行SDK Manager下载安装包,默认从google网站下载,但被GWF和谐了,感谢一位网友提供的镜像站点.具体步骤是:运行SD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBzmlKM.html" rel="bookmark" class="title">一级注册消防工程师招生简章</a>
					<div>
						2015年,公安消防部首次组织一级注册消防工程师资格考试!总部消防培训教材编委会专家空降福州,为您的考试保驾护航!福建消防总队培训基地全封闭集训,打造消防行业的“黄埔军校”! 一.二级注册消防工程师是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoRr2k4.html" rel="bookmark" class="title">预测技术</a>
					<div>
						完工估算(E A C )是根据项目绩效和风险量化对项目总成本的预测.最常用的预测技术就是下述方法的不同形式:• EAC = 截至目前的实际成本加上所有剩余工作的新估算.这种方法通常用于以下两种情况:过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgmLy83.html" rel="bookmark" class="title">手把手教你做音乐播放器（八）桌面小工具（下）（完）</a>
					<div>
						8.4 MusicService的改造 8.4.1 App widget触发MusicService 当App widget的按钮被点击后,会触发隐式定义的Intent发送给MusicService. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mgmg2n3.html" rel="bookmark" class="title">Maven-006-手动部署第三方构件至 nexus 私服</a>
					<div>
						某些 Java 构件因许可证因素,无法公开的部署到公共仓库中:或者,一些小型的开源项目(例如 SourceForge.GitHub 中的一些项目),没有将构件分发到中央仓库中,也没有维护自己的仓库,因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jl61B0.html" rel="bookmark" class="title">&period;NET 中String类功能分类概述</a>
					<div>
						一.比较功能 String.Compare: 成员函数 返回值 功能 String.Compare 小于零.零.大于零. 1.比较两个字符串的大小(按照一定规则) 2.比较两个字符串中子字符串的大小. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
